% Program to Replicate Oxford Handbook Analysis
% Created by Jude Hays January 29, 2007

clear all;
A=wk1read('C:\Documents and Settings\Administrator\Desktop\Oxford Handbook\states\7029003\ICPSR_01294\DS0001\oxford_cs.wk1',1,0);
W1=wk1read('C:\Documents and Settings\Administrator\Desktop\Oxford Handbook\states\7029003\ICPSR_01294\DS0001\oxford_cs_w.wk1');
%M=open('C:\Documents and Settings\jchays\Desktop\Research\Book\chapters\Chapter 2\Chapter_2_Data\M_GC.mat');
%W_LR_1=wk1read('C:\Documents and Settings\jchays\Desktop\Research\Book\chapters\Chapter 2\Chapter_2_Data\W_GC_LR.wk1');
nobs=48;
% normalize W if still necessary
%W_LR=normw(W_LR_1);
W=normw(W1); 
y=A(:,[3]); % column number in the data matrix that corresponds to the dependent variable
x=A(:,[4,5,6,7,8,9,10]); % column numbers in the data matrix that correspond to the independent variables 8,9,10,11,12,
xconstant=ones(nobs,1);
result1 = moran(y,[xconstant x],W);
prt(result1);
result2 = lmerror(y,[xconstant x],W);
prt(result2);


result3 = lmerr_rob(y,[xconstant x],W);
prt(result3);

info.rmin=-1;
info.rmax=1;
info.lflag=0; % 0 required for exact results
vnames=strvcat('y','constant','rskpovpc','noresreq','wage95','instcoad','ipcfold','teitrend','match'); %
results4 = sem(y,[xconstant x],W,info);
prt(results4,vnames);
res = sem(y,[xconstant x],W);
result5 = lratios(y,[xconstant x],W,res);
prt(result5);
result6 = walds(y,x,W);
prt(result6);
results7=sar(y,[xconstant x],W,info);
prt(results7,vnames);
result8 = lmsar_ols(y,[xconstant x],W); 
prt(result8);
result9 = lmsar_ols_rob(y,[xconstant x],W); 
prt(result9);







%B_TEMP=[results.beta;results.rho];
%BSTD_TEMP=[results.bstd;results.pstd];
%i_nobs=sparse(eye(nobs));
%deind_1 = 60;
%deind_2 = 75;
%estcf1 = i_nobs - B_TEMP(30,1)*W - B_TEMP(2,1)*M.time;
%estcf_1 = (B_TEMP(3,1) + B_TEMP(5,1)*deind_1)*inv(estcf1); %conditionial effect of imports
%estcf_2 = (B_TEMP(3,1) + B_TEMP(5,1)*deind_2)*inv(estcf1); %conditionial effect of imports
%estcf_3 = B_TEMP(5,1)*inv(estcf1);
%d_cf_rho1_1 = estcf_1*W*inv(estcf1);
%d_cf_rho1_2 = estcf_2*W*inv(estcf1);
%d_cf_rho1_3 = estcf_3*W*inv(estcf1);
%d_cf_rho_1 = d_cf_rho1_1(1:nobs, 495); % 495 is Germany 1990
%d_cf_rho_2 = d_cf_rho1_2(1:nobs, 495); % 495 is Germany 1990
%d_cf_rho_3 = d_cf_rho1_3(1:nobs, 495); % 495 is Germany 1990
%d_cf_phi1_1 = estcf_1*inv(estcf1);
%d_cf_phi1_2 = estcf_2*inv(estcf1);
%d_cf_phi1_3 = estcf_3*inv(estcf1);
%d_cf_phi_1 = d_cf_phi1_1(1:nobs, 495);
%d_cf_phi_2 = d_cf_phi1_2(1:nobs, 495);
%d_cf_phi_3 = d_cf_phi1_3(1:nobs, 495);
%d_cf_beta1 = inv(estcf1);
%d_cf_beta = d_cf_beta1(1:nobs, 495);
%d_cf_TEMP_1 = [d_cf_rho_1 d_cf_phi_1 d_cf_beta];
%d_cf_TEMP_2 = [d_cf_rho_2 d_cf_phi_2 d_cf_beta];
%d_cf_TEMP_3 = [d_cf_rho_3 d_cf_phi_3 d_cf_beta];
%d_cf_1 = d_cf_TEMP_1(495:nobs,1:3);
%d_cf_2 = d_cf_TEMP_2(495:nobs,1:3);
%d_cf_3 = d_cf_TEMP_3(495:nobs,1:3);
%VCVM_TEMP=[results.vcvm];
%VCVM_1 = [VCVM_TEMP(30,30) VCVM_TEMP(30,2) VCVM_TEMP(30,3)+deind_1*VCVM_TEMP(30,5);  
%VCVM_TEMP(2,30) VCVM_TEMP(2,2) VCVM_TEMP(2,3)+deind_1*VCVM_TEMP(2,5) ;
%VCVM_TEMP(30,3)+deind_1*VCVM_TEMP(30,5) VCVM_TEMP(2,3)+deind_1*VCVM_TEMP(2,5) VCVM_TEMP(3,3)+(deind_1^2)*VCVM_TEMP(5,5)+2*VCVM_TEMP(3,5)];
%VCVM_2 = [VCVM_TEMP(30,30) VCVM_TEMP(30,2) VCVM_TEMP(30,3)+deind_2*VCVM_TEMP(30,5);  
%VCVM_TEMP(2,30) VCVM_TEMP(2,2) VCVM_TEMP(2,3)+deind_2*VCVM_TEMP(2,5) ;
%VCVM_TEMP(30,3)+deind_2*VCVM_TEMP(30,5) VCVM_TEMP(2,3)+deind_2*VCVM_TEMP(2,5) VCVM_TEMP(3,3)+(deind_2^2)*VCVM_TEMP(5,5)+2*VCVM_TEMP(3,5)];
%VCVM_3 = [VCVM_TEMP(30,30) VCVM_TEMP(30,2) VCVM_TEMP(30,5);  
%VCVM_TEMP(2,30) VCVM_TEMP(2,2) VCVM_TEMP(2,5) ;
%VCVM_TEMP(30,5) VCVM_TEMP(2,5) VCVM_TEMP(5,5)] ;
%delta1_1 = d_cf_1*VCVM_1*d_cf_1';
%delta_1 = diag(delta1_1);
%delta1_2 = d_cf_2*VCVM_2*d_cf_2';
%delta_2 = diag(delta1_2);
%delta1_3 = d_cf_3*VCVM_3*d_cf_3';
%delta_diff = diag(delta1_3);
%cf_1 = estcf_1(495:nobs,495);
%cf_2 = estcf_2(495:nobs,495);  
%cf_3 = estcf_3(495:nobs,495);
%cf_diff = cf_1 - cf_2;

%Long-Run Steady-State Spatio-Temporal Effects for deind=deind_2

%i_n=sparse(eye(20));
%estcf1_LR = i_n - B_TEMP(30,1)*W_LR - B_TEMP(2,1)*i_n;
%estcf_LR = (B_TEMP(3,1) + B_TEMP(5,1)*deind_2)*inv(estcf1_LR); %conditionial effect of imports
%d_cf_rho1_LR = estcf_LR*W_LR*inv(estcf1_LR);
%d_cf_rho_LR = d_cf_rho1_LR(1:20,20); 
%d_cf_phi1_LR = estcf_LR*inv(estcf1_LR);
%d_cf_phi_LR = d_cf_phi1_LR(1:20,20);
%d_cf_beta1_LR = inv(estcf1_LR);
%d_cf_beta_LR = d_cf_beta1_LR(1:20,20);
%d_cf_TEMP_LR = [d_cf_rho_LR  d_cf_phi_LR d_cf_beta_LR];
%d_cf_LR = d_cf_TEMP_LR;
%delta1_LR = d_cf_LR*VCVM_2*d_cf_LR';
%delta_LR = diag(delta1_LR);
%cf_LR = estcf_LR;

%Short-Run Spatial Effects for deind=deind_2

%i_n=sparse(eye(20));
%estcf1_SR = i_n - B_TEMP(30,1)*W_LR ;
%estcf_SR = (B_TEMP(3,1) + B_TEMP(5,1)*deind_2)*inv(estcf1_SR); %conditionial effect of imports
%d_cf_rho1_SR = estcf_SR*W_LR*inv(estcf1_SR);
%d_cf_rho_SR = d_cf_rho1_SR(1:20,20); 
%d_cf_beta1_SR = inv(estcf1_SR);
%d_cf_beta_SR = d_cf_beta1_SR(1:20,20);
%d_cf_TEMP_SR = [d_cf_rho_SR d_cf_beta_SR];
%d_cf_SR = d_cf_TEMP_SR;
%VCVM_4 = [VCVM_TEMP(30,30) VCVM_TEMP(30,3)+deind_2*VCVM_TEMP(30,5);  
%VCVM_TEMP(30,3)+deind_2*VCVM_TEMP(30,5) VCVM_TEMP(3,3)+(deind_2^2)*VCVM_TEMP(5,5)+2*VCVM_TEMP(3,5)];
%delta1_SR = d_cf_SR*VCVM_4*d_cf_SR';
%delta_SR = diag(delta1_SR);
%cf_SR = estcf_SR;
